Attribute VB_Name = "Modulo1"
Option Explicit

Declare Sub LZClose Lib "lz32.dll" (ByVal hfFile As Long)
Declare Function lwrite Lib "kernel32" Alias "_lwrite" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal wBytes As Long) As Long
Declare Sub LZDone Lib "lz32.dll" ()
Declare Function LZOpenFile Lib "lz32.dll" Alias "LZOpenFileA" (ByVal lpszFile As String, lpOf As OFSTRUCT, ByVal style As Long) As Long
Declare Function LZInit Lib "lz32.dll" (ByVal hfSrc As Long) As Long
Declare Function LZRead Lib "lz32.dll" (ByVal hfFile As Long, ByVal lpvBuf As String, ByVal cbread As Long) As Long
Declare Function LZSeek Lib "lz32.dll" (ByVal hfFile As Long, ByVal lOffset As Long, ByVal nOrigin As Long) As Long
Declare Function LZStart Lib "lz32.dll" () As Long
Declare Function GetExpandedName Lib "lz32.dll" Alias "GetExpandedNameA" (ByVal lpszSource As String, ByVal lpszBuffer As String) As Long
Declare Function hread Lib "kernel32" Alias "_hread" (ByVal hFile As Long, lpBuffer As Any, ByVal lBytes As Long) As Long
Declare Function hwrite Lib "kernel32" Alias "_hwrite" (ByVal hFile As Long, ByVal lpBuffer As String, ByVal lBytes As Long) As Long


Function lzCopyFile(Src As String, Dst As String, Animate As Animation, Pic As PictureBox, LabDescription As Label) As Single
Static Buf$
Dim BTest!, FSize!
Dim Chunk%, F1%, F2%
Const BUFSIZE = 8048
Dim Bytes As Long, Bytes1 As Long, Percents As Long

On Error GoTo FileCopyError

Bytes1 = 0
F1 = LZOpenFile(Src, OFSTRUCT1, &H0)
F2 = LZInit(F1)
If F2 = -1 Then
FSize = FileLen(Src)
F2 = LZOpenFile(Dst, OFSTRUCT2, &H1000)
Visibile False
Animate.Play
DoEvents
Buf = Space$(BUFSIZE)
Do
BTest = LZRead(F1, Buf, BUFSIZE)
If BTest > 0 Then
Bytes = lwrite(F2, Buf, BTest)
Bytes1 = Bytes1 + Bytes
Percents = (Bytes1 / FSize) * 100
If Percents > 100 Then Percents = 100
UpdateStatus Pic, Percents, 1
DoEvents
Else
Exit Do
End If
Loop While BTest = BUFSIZE
LZClose (F2)
LZClose (F1)
Animate.Stop
Visibile True
UpdateStatus Pic, 0
LabDescription.Caption = "Fine Decompressione del file"
Beep
Else
LZClose (F1)
LabDescription.Caption = "Errore Decompressione del file"
MsgBox "Il file scelto non  compresso dal Compressore della Microsoft", vbExclamation, "Errore File"
Exit Function
End If
Exit Function 'exit the procedure

FileCopyError: 'file copy error label
Animate.Stop
Visibile True
Beep
MsgBox "Errore di Decompressione!, Riprova di nuovo..." 'display message box with error
LZClose F1 'closes the source file
LZClose F2 'closes the destination file
Exit Function 'exit the procedure

End Function
Public Function OriginalName(Src As String) As String
Dim H As Integer
OriginalName = Space$(64)
H = GetExpandedName(Src, OriginalName)
OriginalName = Trim$(OriginalName)
End Function

